options mlogic mprint;
%macro csbmva_attribprps (input_ds =, output_ds=);

/*Start: Modified for hotfix defect id:S1106744 to consider all records, accepted and rejected for score shift index calculation */
%local input_col_act_tmp input_col_dev_tmp cnt_stab_col;

%let cnt_stab_col=0;
proc sql noprint;
select count(*) into :cnt_stab_col from dictionary.columns 
where  strip(kupcase(memname))=%kupcase("&input_ds") and kupcase(name)='NO_OF_RECORDS_ACTUAL_ALL';
quit;
%let cnt_stab_col=&cnt_stab_col;

%if &cnt_stab_col gt 0 %then %do; /*Additional condition for hot_fix related to score shift index calculation*/
	%let input_col_act_tmp = NO_OF_RECORDS_ACTUAL_ALL;
	%let input_col_dev_tmp = NO_OF_RECORDS_DEV;
%end;
%else %do;
	%let input_col_act_tmp = NO_OF_RECORDS_ACTUAL;
	%let input_col_dev_tmp = NO_OF_RECORDS_DEV;
%end;

/*End: Modified for hotfix defect id:S1106744 to consider all records, accepted and rejected for SSI calculation */


proc sql noprint;
   	select min(seq_no), max(seq_no)
   	into :atb_nm_min  ,:atb_nm_max separated by "#"  
    from &input_ds;
quit;
%do i = &atb_nm_min %to &atb_nm_max;
proc sql;
create table table_&i as select distinct to_score,score_range,&input_col_act_tmp. as no_of_records_actual_&i,
&input_col_dev_tmp. as no_of_records_dev_&i
from &input_ds where seq_no =&i;
quit;


proc sql;
select sum(NO_OF_RECORDS_ACTUAL_&i),sum(NO_OF_RECORDS_dev_&i) into: act_tot,:dev_tot from table_&i;
quit;

data table_&i;
set table_&i;
act_prop_&i = (NO_OF_RECORDS_ACTUAL_&i/&act_tot);
dev_prop_&i = (NO_OF_RECORDS_dev_&i/&dev_tot);


run;

data table_&i;
retain cum_act_prop_&i 0;
retain cum_dev_prop_&i 0; 
retain  cum_act_&i 0;
retain cum_dev_&i 0;
set table_&i;
cum_act_prop_&i = cum_act_prop_&i+act_prop_&i;
cum_dev_prop_&i = cum_dev_prop_&i+dev_prop_&i;
cum_act_&i = cum_act_&i+NO_OF_RECORDS_ACTUAL_&i;
cum_dev_&i = cum_dev_&i+NO_OF_RECORDS_dev_&i;

run;
proc sql;
create table table_&i as select to_score,
score_range,
cum_act_&i,cum_dev_&i,act_prop_&i,dev_prop_&i ,
cum_act_prop_&i,cum_dev_prop_&i from table_&i;
quit;

%end;

%put &atb_nm_min;
%let atb_nm_min = &atb_nm_min;
	
data &output_ds;
set table_&atb_nm_min;
run;


%do j = %eval(&atb_nm_min+1) %to &atb_nm_max;

data &output_ds;
merge &output_ds table_&j;
by to_score;
run;
%end;


%do k = &atb_nm_min %to &atb_nm_max;
proc sql;
drop table table_&k;
quit;
%end;

%mend csbmva_attribprps;
