
	/* Post action macro called after actual job calculation is done and ARM is populated*/
%macro csbmva_post_bck_calc_wrapper(m_action_cd=, m_purpose_sk=, m_key_sk=);

	%local m_purpose_cd;
	
	%let m_purpose_cd = ;
	proc sql noprint;
		select kupcase(pm.purpose_cd) into :m_purpose_cd
		from &dabt_lib..purpose_master pm
		where pm.purpose_sk = &m_purpose_sk;
	quit;

    %let m_purpose_cd = &m_purpose_cd;

	/* If update LGD post build flag is set to Y then update the LGD. 
		This parameter value is taken from apdm.parameter_value_dtl table.*/
	%if &m_purpose_cd eq LGD and %upcase(&CSB_UPDT_LGD_POST_BUILD_FLG) eq Y %then %do; /*i18NOK:LINE */
		%let m_abt_type_cd = BCK;

		%let m_level_cd = ;
		%let m_level_sk = ;
		proc sql noprint;
			select kupcase(lm.level_cd), lm.level_sk
					into :m_level_cd, :m_level_sk
			from &csb_apdm_libref..model_master_extension mme
				inner join &dabt_lib..level_master lm
				on (mme.level_sk = lm.level_sk)
			where mme.model_key = &m_key_sk;
		quit;

	    %let m_level_cd = &m_level_cd;
		%let m_level_sk = &m_level_sk;

		%let m_sub_of_analysis_cd = &m_level_cd;
		%let m_sub_rk_col_nm = ;
		
		/* Get key column name */
		/* Assumption: key constitutes of only one column */
		proc sql noprint;
			select source_column_nm into :m_sub_rk_col_nm
			from &dabt_lib..level_key_column_dtl lkcd inner join
				&dabt_lib..source_column_master scm
				on (lkcd.key_column_sk = scm.source_column_sk)
			where upcase(key_type_cd) = "RETAIN_KEY" and lkcd.level_sk = &m_level_sk; /*i18NOK:LINE */
		quit;
		%let m_sub_rk_col_nm = &m_sub_rk_col_nm;

		
		%let m_tbl_libref = &DABT_BACKTESTING_ABT_LIBREF;
		%let m_tbl_nm = ;

		/* Get table name in which update is to be done */
		proc sql noprint;
			select scr_abt_ds into :m_tbl_nm
			from &csb_apdm_libref..build_backtest_abt_status
			where model_rk = &m_key_sk;
		quit;
		%let m_tbl_nm = &m_tbl_nm;
		%let m_sub_retain_key_lib = &m_tbl_libref;
		%let m_sub_retain_key_tbl_nm = &m_tbl_nm;

		%let m_lgd_column_nm = LGD;
		%let m_ead_column_nm = EAD;
		%let m_def_dt_column_nm = DEFAULT_DT;

		%csbmva_calc_upd_lgd_var_wrapper(m_abt_type_cd=&m_abt_type_cd, m_object_sk=&m_key_sk, m_subject_of_analysis_cd=&m_sub_of_analysis_cd,
									m_subject_retain_key_libref=&m_sub_retain_key_lib,m_subject_retain_key_tbl_nm=&m_sub_retain_key_tbl_nm,
									m_subject_rk_column_nm=&m_sub_rk_col_nm, m_to_be_upd_tbl_libref=&m_tbl_libref,
									m_to_be_upd_tbl_nm=&m_tbl_nm, m_to_be_upd_lgd_column_nm=&m_lgd_column_nm,
									m_to_be_upd_ead_column_nm=&m_ead_column_nm,m_to_be_upd_def_dt_column_nm=&m_def_dt_column_nm);
	%end;

%mend csbmva_post_bck_calc_wrapper;
