
%macro csbmva_setoutcome_period(m_action_cd= , m_purpose_sk= , m_key_sk=);

%let m_action_cd = &m_action_cd;
%let m_purpose_sk = &m_purpose_sk;
%let m_scoring_template_sk = &m_key_sk;

%let m_scr_bld_dttm = &m_scoring_as_of_dt.;

%let m_out_per_cnt = ;
%let m_out_freq_exp = ;
%let m_src_grn_sk = ;
%let m_src_time_cd = ;

proc sql noprint;
   select outcome_period_cnt, dttm_interval_expression
         into :m_out_per_cnt, :m_out_freq_exp
   from &m_src_lib..scoring_model(where =(scoring_template_sk = &m_scoring_template_sk.)) as sm
         left join &m_src_lib..time_frequency_master as tfm
   on (sm.outcome_period_time_freq_sk = tfm.time_frequency_sk);
quit;

proc sql noprint;

  select mab.source_data_time_grain_sk into  :m_src_grn_sk

  from &m_src_lib..scoring_model(where =(scoring_template_sk = &m_scoring_template_sk.)) as sm
            inner join &m_src_lib..model_master mm on (mm.model_sk=sm.model_sk)
           inner join &m_src_lib..model_x_modeling_abt mm_x_ma on (mm.model_sk=mm_x_ma.model_sk)
           inner join &m_src_lib..modeling_abt_master mab on (mm_x_ma.abt_sk = mab.abt_sk)    
    ;

quit;

%let m_out_per_cnt = &m_out_per_cnt;
%let m_out_freq_exp = &m_out_freq_exp;
%let m_src_grn_sk = &m_src_grn_sk;

proc sql noprint; 
   select time_frequency_cd into :m_src_time_cd
   from &m_src_lib..time_frequency_master
   where time_frequency_sk = &m_src_grn_sk.;
quit;

%let m_src_time_cd = %kupcase(&m_src_time_cd);

%let m_src_time_align = END;

%if &m_src_time_cd eq DAY %then %do;
     %let m_src_time_align = SAME;
%end;

/* Commented while fixing S1068586. 
proc sql noprint;
  select put(max(scoring_processed_dttm),nldatm.) into :latest_processed_dttm
  from &m_src_lib..scoring_control_detail
  where scoring_template_sk eq &m_scoring_template_sk. and scoring_as_of_dttm eq &m_scr_bld_dttm.;
quit;
*/

/* In case earlier scoring run execution has failed fro same scoring template and scoring as of date then we want to update outcome period for just latest scoring run*/
proc sql noprint;
  select max(scoring_control_detail_sk) into :m_scoring_control_detail_sk
  from &m_src_lib..scoring_control_detail
  where scoring_template_sk eq &m_scoring_template_sk. and scoring_as_of_dttm eq &m_scr_bld_dttm.;
quit;

%let m_scoring_control_detail_sk = &m_scoring_control_detail_sk;

/*
%let latest_processed_dttm = &latest_processed_dttm;

%put &latest_processed_dttm;
*/

/*
 For a given scoring run, actual calculation  should be done till  
(Scoring Date + 
(period signified a solution level CSB_DEF_CPTR_PERIOD_POST_LGD_SCR Parameter which define default capture period after LGD scoring ) + 
(recovery period i.e. outcoem period of model)

By default it was set as (Scoring Date + (recovery period i.e. outcoem period of model)).
Now in update below we are adding &CSB_DEF_CPTR_PERIOD_POST_LGD_SCR. months to it. 
)
*/



proc sql noprint;
  update &m_src_lib..scoring_control_detail
  set outcome_period_end_dttm = intnx('DTMONTH',outcome_period_end_dttm,&CSB_DEF_CPTR_PERIOD_POST_LGD_SCR.,"&m_src_time_align.")
  where scoring_template_sk eq &m_scoring_template_sk. and scoring_as_of_dttm eq &m_scr_bld_dttm. and 
  /* Commented while fixing S1068586. 
  	
  	put(scoring_processed_dttm,nldatm.) eq "&latest_processed_dttm.";
   */
   
   /* Line below is added as fix for S1068586. */
        scoring_control_detail_sk = &m_scoring_control_detail_sk.;
quit;

%mend csbmva_setoutcome_period;
