options mlogic mprint;

%macro csbmva_wtgscr(input_ds=,output_ds=);


/*Start: Modified for hotfix defect id:S1106744 to consider all records, accepted and rejected for score shift index calculation */
%local input_col_act_tmp input_col_dev_tmp cnt_stab_col;

%let cnt_stab_col=0;
proc sql noprint;
select count(*) into :cnt_stab_col from dictionary.columns 
where strip(kupcase(memname))=%kupcase("&input_ds") and kupcase(name)='NO_OF_RECORDS_ACTUAL_ALL';
quit;
%let cnt_stab_col=&cnt_stab_col;

%if &cnt_stab_col gt 0 %then %do; /*Additional condition for hot_fix related to score shift index calculation*/
	%let input_col_act_tmp = NO_OF_RECORDS_ACTUAL_ALL;
	%let input_col_dev_tmp = NO_OF_RECORDS_DEV;
%end;
%else %do;
	%let input_col_act_tmp = NO_OF_RECORDS_ACTUAL;
	%let input_col_dev_tmp = NO_OF_RECORDS_DEV;
%end;

/*End: Modified for hotfix defect id:S1106744 to consider all records, accepted and rejected for SSI calculation */


proc sql noprint;
	select SUM(&input_col_act_tmp.),SUM(&input_col_dev_tmp.) into:VAR_SUM_ACT, :VAR_SUM_DEV 
	from &input_ds;
quit;

%let VAR_SUM_ACT=&VAR_SUM_ACT.;
%let VAR_SUM_DEV=&VAR_SUM_DEV.;

data &output_ds(keep=ATTR_PROP_ACT ATTR_PROP_DEV ACT_WA DEV_WA SCORECARD_POINTS
					VARIABLE_NAME ATTRIBUTE_NAME seq_no); 
set &input_ds;
	

	ATTR_PROP_ACT=&input_col_act_tmp./&VAR_SUM_ACT.;
	ATTR_PROP_DEV=&input_col_dev_tmp./&VAR_SUM_DEV.;
	ACT_WA=ATTR_PROP_ACT*SCORECARD_POINTS;
	DEV_WA=ATTR_PROP_DEV*SCORECARD_POINTS;
/*	SHIFT=(ACT_WA- DEV_WA)/ DEV_WA;*/
run;

%mend csbmva_wtgscr;
/*%scr_shift_index(out_lib=work,input_ds=feed,output_ds=test_feed)*/
